diff -r 6b3ac7e864ba source/ps/scripting/JSInterface_VFS.cpp
--- a/source/ps/scripting/JSInterface_VFS.cpp	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/ps/scripting/JSInterface_VFS.cpp	Thu Nov 04 14:52:01 2010 +0000
@@ -29,15 +29,15 @@
 // shared error handling code
 #define JS_CHECK_FILE_ERR(err)\
 	/* this is liable to happen often, so don't complain */\
-	if(err == ERR::VFS_FILE_NOT_FOUND)\
+	if (err == ERR::VFS_FILE_NOT_FOUND)\
 	{\
-		*rval = JSVAL_NULL;\
-		return( JS_TRUE );\
+		JS_SET_RVAL(cx, vp, JSVAL_NULL);\
+		return JS_TRUE;\
 	}\
 	/* unknown failure. we return an error (akin to an exception in JS) that
 	   stops the script to make sure this error is noticed. */\
-	else if(err < 0)\
-		return( JS_FALSE );\
+	else if (err < 0)\
+		return JS_FALSE;\
 	/* else: success */
 
 
@@ -54,13 +54,13 @@
 		: cx(cx_)
 	{
 		filename_array = JS_NewArrayObject(cx, 0, NULL);
-		JS_AddRoot(cx, &filename_array);
+		JS_AddObjectRoot(cx, &filename_array);
 		cur_idx = 0;
 	}
 
 	~BuildDirEntListState()
 	{
-		JS_RemoveRoot(cx, &filename_array);
+		JS_RemoveObjectRoot(cx, &filename_array);
 	}
 };
 
@@ -85,44 +85,45 @@
 //
 // note: full pathnames of each file/subdirectory are returned,
 // ready for use as a "filename" for the other functions.
-JSBool JSI_VFS::BuildDirEntList( JSContext* cx, JSObject* UNUSED(obj), uintN argc, jsval* argv, jsval* rval )
+JSBool JSI_VFS::BuildDirEntList(JSContext* cx, uintN argc, jsval* vp)
 {
 	//
 	// get arguments
 	//
 
-	debug_assert( argc >= 1 );
+	JSU_REQUIRE_MIN_PARAMS(1);
+
 	CStr path;
-	if( !ToPrimitive<CStr>( cx, argv[0], path ) )
-		return( JS_FALSE );
+	if (!ToPrimitive<CStr> (cx, JS_ARGV(cx, vp)[0], path))
+		return JS_FALSE;
 
 	CStrW filter_str = L"";
-	if(argc >= 2)
+	if (argc >= 2)
 	{
-		if( !ToPrimitive<CStrW>( cx, argv[1], filter_str ) )
-			return( JS_FALSE );
+		if (!ToPrimitive<CStrW> (cx, JS_ARGV(cx, vp)[1], filter_str))
+			return JS_FALSE;
 	}
 	// convert to const wchar_t*; if there's no filter, pass 0 for speed
 	// (interpreted as: "accept all files without comparing").
 	const wchar_t* filter = 0;
-	if(!filter_str.empty())
+	if (!filter_str.empty())
 		filter = filter_str.c_str();
 
 	bool recursive = false;
-	if(argc >= 3)
+	if (argc >= 3)
 	{
-		if( !ToPrimitive<bool>( cx, argv[2], recursive ) )
-			return( JS_FALSE );
+		if (!ToPrimitive<bool> (cx, JS_ARGV(cx, vp)[2], recursive))
+			return JS_FALSE;
 	}
-	int flags = recursive? fs_util::DIR_RECURSIVE : 0;
+	int flags = recursive ? fs_util::DIR_RECURSIVE : 0;
 
 
 	// build array in the callback function
 	BuildDirEntListState state(cx);
 	fs_util::ForEachFile(g_VFS, CStrW(path), BuildDirEntListCB, (uintptr_t)&state, filter, flags);
 
-	*rval = OBJECT_TO_JSVAL( state.filename_array );
-	return( JS_TRUE );
+	JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(state.filename_array));
+	return JS_TRUE;
 }
 
 
@@ -130,19 +131,20 @@
 //
 // mtime = getFileMTime(filename);
 //   filename: VFS filename (may include path)
-JSBool JSI_VFS::GetFileMTime( JSContext* cx, JSObject* UNUSED(obj), uintN argc, jsval* argv, jsval* rval )
+JSBool JSI_VFS::GetFileMTime(JSContext* cx, uintN argc, jsval* vp)
 {
-	debug_assert( argc >= 1 );
+	JSU_REQUIRE_MIN_PARAMS(1);
+
 	CStr filename;
-	if( !ToPrimitive<CStr>( cx, argv[0], filename ) )
-		return( JS_FALSE );
+	if (!ToPrimitive<CStr> (cx, JS_ARGV(cx, vp)[0], filename))
+		return JS_FALSE;
 
 	FileInfo fileInfo;
 	LibError err = g_VFS->GetFileInfo(CStrW(filename), &fileInfo);
-	JS_CHECK_FILE_ERR( err );
+	JS_CHECK_FILE_ERR(err);
 
-	*rval = ToJSVal( (double)fileInfo.MTime() );
-	return( JS_TRUE );
+	JS_SET_RVAL(cx, vp, ToJSVal((double)fileInfo.MTime()));
+	return JS_TRUE;
 }
 
 
@@ -150,19 +152,20 @@
 //
 // size = getFileSize(filename);
 //   filename: VFS filename (may include path)
-JSBool JSI_VFS::GetFileSize( JSContext* cx, JSObject* UNUSED(obj), uintN argc, jsval* argv, jsval* rval )
+JSBool JSI_VFS::GetFileSize(JSContext* cx, uintN argc, jsval* vp)
 {
-	debug_assert( argc >= 1 );
+	JSU_REQUIRE_MIN_PARAMS(1);
+
 	CStr filename;
-	if( !ToPrimitive<CStr>( cx, argv[0], filename ) )
-		return( JS_FALSE );
+	if (!ToPrimitive<CStr> (cx, JS_ARGV(cx, vp)[0], filename))
+		return JS_FALSE;
 
 	FileInfo fileInfo;
 	LibError err = g_VFS->GetFileInfo(CStrW(filename), &fileInfo);
 	JS_CHECK_FILE_ERR(err);
 
-	*rval = ToJSVal( (unsigned)fileInfo.Size() );
-	return( JS_TRUE );
+	JS_SET_RVAL(cx, vp, ToJSVal( (unsigned)fileInfo.Size() ));
+	return JS_TRUE;
 }
 
 
@@ -170,25 +173,27 @@
 //
 // contents = readFile(filename);
 //   filename: VFS filename (may include path)
-JSBool JSI_VFS::ReadFile( JSContext* cx, JSObject* UNUSED(obj), uintN argc, jsval* argv, jsval* rval )
+JSBool JSI_VFS::ReadFile(JSContext* cx, uintN argc, jsval* vp)
 {
-	debug_assert( argc >= 1 );
+	JSU_REQUIRE_MIN_PARAMS(1);
+
 	CStr filename;
-	if( !ToPrimitive<CStr>( cx, argv[0], filename ) )
-		return( JS_FALSE );
+	if (!ToPrimitive<CStr> (cx, JS_ARGV(cx, vp)[0], filename))
+		return JS_FALSE;
 
-	shared_ptr<u8> buf; size_t size;
-	LibError err = g_VFS->LoadFile( CStrW(filename), buf, size );
+	shared_ptr<u8> buf;
+	size_t size;
+	LibError err = g_VFS->LoadFile(CStrW(filename), buf, size);
 	JS_CHECK_FILE_ERR( err );
 
-	CStr contents( (const char*)buf.get(), size );
+	CStr contents((const char*)buf.get(), size);
 
 	// Fix CRLF line endings. (This function will only ever be used on text files.)
 	contents.Replace("\r\n", "\n");
 
 	// Decode as UTF-8
-	*rval = ToJSVal( contents.FromUTF8() );
-	return( JS_TRUE );
+	JS_SET_RVAL(cx, vp, ToJSVal( contents.FromUTF8() ));
+	return JS_TRUE;
 }
 
 
@@ -196,22 +201,24 @@
 //
 // lines = readFileLines(filename);
 //   filename: VFS filename (may include path)
-JSBool JSI_VFS::ReadFileLines( JSContext* cx, JSObject* UNUSED(obj), uintN argc, jsval* argv, jsval* rval )
+JSBool JSI_VFS::ReadFileLines(JSContext* cx, uintN argc, jsval* vp)
 {
-	debug_assert( argc >= 1 );
+	JSU_REQUIRE_MIN_PARAMS(1);
+
 	CStr filename;
-	if( !ToPrimitive<CStr>( cx, argv[0], filename ) )
-		return( JS_FALSE );
+	if (!ToPrimitive<CStr> (cx, JS_ARGV(cx, vp)[0], filename))
+		return (JS_FALSE);
 
 	//
 	// read file
 	//
 
-	shared_ptr<u8> buf; size_t size;
-	LibError err = g_VFS->LoadFile( CStrW(filename), buf, size );
+	shared_ptr<u8> buf;
+	size_t size;
+	LibError err = g_VFS->LoadFile(CStrW(filename), buf, size);
 	JS_CHECK_FILE_ERR( err );
 
-	CStr contents( (const char*)buf.get(), size );
+	CStr contents((const char*)buf.get(), size);
 
 	// Fix CRLF line endings. (This function will only ever be used on text files.)
 	contents.Replace("\r\n", "\n");
@@ -220,32 +227,33 @@
 	// split into array of strings (one per line)
 	//
 
-	std::stringstream ss( contents );
+	std::stringstream ss(contents);
 
-	JSObject* line_array = JS_NewArrayObject( cx, 0, NULL );
-	JS_AddRoot(cx, &line_array);
+	JSObject* line_array = JS_NewArrayObject(cx, 0, NULL);
 
 	std::string line;
 	int cur_line = 0;
-	while( std::getline( ss, line ) )
+	while (std::getline(ss, line))
 	{
 		// Decode each line as UTF-8
-		jsval val = ToJSVal( CStr( line ).FromUTF8() );
-		JS_SetElement( cx, line_array, cur_line++, &val );
+		jsval val = ToJSVal(CStr(line).FromUTF8());
+		JS_SetElement(cx, line_array, cur_line++, &val);
 	}
 
-	JS_RemoveRoot(cx, &line_array);
-
-	*rval = OBJECT_TO_JSVAL( line_array );
-	return( JS_TRUE );
+	JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL( line_array ));
+	return JS_TRUE ;
 }
 
 
 // vfs_optimizer
 
-JSBool JSI_VFS::ArchiveBuilderCancel(JSContext* UNUSED(cx), JSObject* UNUSED(obj), uintN argc, jsval* UNUSED(argv), jsval* UNUSED(rval) )
+JSBool JSI_VFS::ArchiveBuilderCancel(JSContext* cx, uintN argc, jsval* vp)
 {
-	debug_assert( argc == 0 );
+	UNUSED2(cx);
+	UNUSED2(argc);
+
 //	vfs_opt_auto_build_cancel();
-	return( JS_TRUE );
+
+	JS_SET_RVAL(cx, vp, JSVAL_VOID);
+	return JS_TRUE;
 }
diff -r 6b3ac7e864ba source/ps/scripting/JSInterface_VFS.h
--- a/source/ps/scripting/JSInterface_VFS.h	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/ps/scripting/JSInterface_VFS.h	Thu Nov 04 14:52:01 2010 +0000
@@ -38,36 +38,36 @@
 	//
 	// note: full pathnames of each file/subdirectory are returned,
 	// ready for use as a "filename" for the other functions.
-	JSBool BuildDirEntList( JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval );
+	JSBool BuildDirEntList(JSContext* cx, uintN argc, jsval* vp);
 
 	// Return time [seconds since 1970] of the last modification to the specified file.
 	//
 	// mtime = getFileMTime(filename);
 	//   filename: VFS filename (may include path)
-	JSBool GetFileMTime( JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval );
+	JSBool GetFileMTime(JSContext* cx, uintN argc, jsval* vp);
 
 	// Return current size of file.
 	//
 	// size = getFileSize(filename);
 	//   filename: VFS filename (may include path)
-	JSBool GetFileSize( JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval );
+	JSBool GetFileSize(JSContext* cx, uintN argc, jsval* vp);
 
 	// Return file contents in a string.
 	//
 	// contents = readFile(filename);
 	//   filename: VFS filename (may include path)
-	JSBool ReadFile( JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval );
+	JSBool ReadFile(JSContext* cx, uintN argc, jsval* vp);
 
 	// Return file contents as an array of lines.
 	//
 	// lines = readFileLines(filename);
 	//   filename: VFS filename (may include path)
-	JSBool ReadFileLines( JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval );
+	JSBool ReadFileLines(JSContext* cx, uintN argc, jsval* vp);
 
 	// Abort the current archive build operation (no-op if not currently active).
 	//
 	// archiveBuilderCancel();
-	JSBool ArchiveBuilderCancel(JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval );
+	JSBool ArchiveBuilderCancel(JSContext* cx, uintN argc, jsval* vp);
 }
 
 #endif
diff -r 6b3ac7e864ba source/scripting/JSConversions.cpp
--- a/source/scripting/JSConversions.cpp	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/scripting/JSConversions.cpp	Thu Nov 04 14:52:01 2010 +0000
@@ -180,12 +180,16 @@
 
 template<> jsval ToJSVal<double>( const double& Native )
 {
-	return( DOUBLE_TO_JSVAL( JS_NewDouble( g_ScriptingHost.getContext(), Native ) ) );
+	jsval val = JSVAL_VOID;
+	JS_NewNumberValue( g_ScriptingHost.getContext(), Native, &val );
+	return val;
 }
 
 template<> jsval ToJSVal<double>( double& Native )
 {
-	return( DOUBLE_TO_JSVAL( JS_NewDouble( g_ScriptingHost.getContext(), Native ) ) );
+	jsval val = JSVAL_VOID;
+	JS_NewNumberValue( g_ScriptingHost.getContext(), Native, &val );
+	return val;
 }
 
 template<> bool ToPrimitive<double>( JSContext* cx, jsval v, double& Storage )
@@ -200,12 +204,16 @@
 
 template<> jsval ToJSVal<float>( const float& Native )
 {
-	return( DOUBLE_TO_JSVAL( JS_NewDouble( g_ScriptingHost.getContext(), Native ) ) );
+	jsval val = JSVAL_VOID;
+	JS_NewNumberValue( g_ScriptingHost.getContext(), Native, &val );
+	return val;
 }
 
 template<> jsval ToJSVal<float>( float& Native )
 {
-	return( DOUBLE_TO_JSVAL( JS_NewDouble( g_ScriptingHost.getContext(), Native ) ) );
+	jsval val = JSVAL_VOID;
+	JS_NewNumberValue( g_ScriptingHost.getContext(), Native, &val );
+	return val;
 }
 
 template<> bool ToPrimitive<float>( JSContext* cx, jsval v, float& Storage )
@@ -304,18 +312,12 @@
 	stringParser.InputTaskType( "string", "_$value_" );
 	CParserLine result;
 	result.ParseString( stringParser, CStr(Native) );
-	bool boolResult; int intResult; float floatResult;
+	bool boolResult;
+	float floatResult;
 
 	if( result.GetArgFloat( 0, floatResult ) )
-	{
-		if( floatResult == floor( floatResult ) )
-		{
-			intResult = (int)floatResult;
-			if( INT_FITS_IN_JSVAL( intResult ) )
-				return( ToJSVal( intResult ) );
-		}
 		return( ToJSVal( floatResult ) );
-	}
+
 	if( result.GetArgBool( 0, boolResult ) )
 		return( BOOLEAN_TO_JSVAL( boolResult ) ); 
 	
diff -r 6b3ac7e864ba source/scripting/JSUtil.cpp
--- a/source/scripting/JSUtil.cpp	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/scripting/JSUtil.cpp	Thu Nov 04 14:52:01 2010 +0000
@@ -19,12 +19,12 @@
 
 #include "SpiderMonkey.h"
 
-jsval jsu_report_param_error(JSContext* cx, jsval* rval)
+JSBool jsu_report_param_error(JSContext* cx, jsval* vp)
 {
 	JS_ReportError(cx, "Invalid parameter(s) or count");
 
-	if(rval)
-		*rval = JSVAL_NULL;
+	if (vp)
+		JS_SET_RVAL(cx, vp, JSVAL_NULL);
 
 	// yes, we had an error, but returning JS_FALSE would cause SpiderMonkey
 	// to abort. that would be hard to debug.
diff -r 6b3ac7e864ba source/scripting/JSUtil.h
--- a/source/scripting/JSUtil.h	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/scripting/JSUtil.h	Thu Nov 04 14:52:01 2010 +0000
@@ -17,7 +17,7 @@
 
 // included from SpiderMonkey.h
 
-extern jsval jsu_report_param_error(JSContext* cx, jsval* rval);
+extern JSBool jsu_report_param_error(JSContext* cx, jsval* vp);
 
 
 // consistent argc checking for normal function wrappers: reports an
@@ -25,24 +25,23 @@
 // .. require exact number (most common case)
 #define JSU_REQUIRE_PARAMS(exact_number)\
 	if(argc != exact_number)\
-		return jsu_report_param_error(cx, rval);
+		return jsu_report_param_error(cx, vp);
 // .. require 0 params (avoids L4 warning "unused argv param")
 #define JSU_REQUIRE_NO_PARAMS()\
-	UNUSED2(argv);\
 	if(argc != 0)\
-		return jsu_report_param_error(cx, rval);
+		return jsu_report_param_error(cx, vp);
 // .. require a certain range (e.g. due to optional params)
 #define JSU_REQUIRE_PARAM_RANGE(min_number, max_number)\
 	if(!(min_number <= argc && argc <= max_number))\
-		return jsu_report_param_error(cx, rval);
+		return jsu_report_param_error(cx, vp);
 // .. require at most a certain count
 #define JSU_REQUIRE_MAX_PARAMS(max_number)\
 	if(argc > max_number)\
-		return jsu_report_param_error(cx, rval);
+		return jsu_report_param_error(cx, vp);
 // .. require at least a certain count (rarely needed)
 #define JSU_REQUIRE_MIN_PARAMS(min_number)\
 	if(argc < min_number)\
-		return jsu_report_param_error(cx, rval);
+		return jsu_report_param_error(cx, vp);
 
 // same as JSU_REQUIRE_PARAMS, but used from C++ functions that are
 // a bit further removed from SpiderMonkey, i.e. return a
diff -r 6b3ac7e864ba source/scripting/ScriptGlue.cpp
--- a/source/scripting/ScriptGlue.cpp	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/scripting/ScriptGlue.cpp	Thu Nov 04 14:52:01 2010 +0000
@@ -31,8 +31,6 @@
 #include "graphics/MapWriter.h"
 #include "graphics/Unit.h"
 #include "graphics/UnitManager.h"
-#include "graphics/scripting/JSInterface_Camera.h"
-#include "graphics/scripting/JSInterface_LightEnv.h"
 #include "gui/GUIManager.h"
 #include "gui/IGUIObject.h"
 #include "lib/frequency_filter.h"
@@ -109,24 +107,26 @@
 	js_timer_clients[0].sum.SetToZero();
 }
 
-JSBool StartJsTimer(JSContext* cx, JSObject*, uintN argc, jsval* argv, jsval* rval)
+JSBool StartJsTimer(JSContext* cx, uintN argc, jsval* vp)
 {
 	ONCE(InitJsTimers());
 
 	JSU_REQUIRE_PARAMS(1);
-	size_t slot = ToPrimitive<size_t>(argv[0]);
+	size_t slot = ToPrimitive<size_t>(JS_ARGV(cx, vp)[0]);
 	if (slot >= MAX_JS_TIMERS)
 		return JS_FALSE;
 
 	js_start_times[slot].SetFromTimer();
+
+	JS_SET_RVAL(cx, vp, JSVAL_VOID);
 	return JS_TRUE;
 }
 
 
-JSBool StopJsTimer(JSContext* cx, JSObject*, uintN argc, jsval* argv, jsval* rval)
+JSBool StopJsTimer(JSContext* cx, uintN argc, jsval* vp)
 {
 	JSU_REQUIRE_PARAMS(1);
-	size_t slot = ToPrimitive<size_t>(argv[0]);
+	size_t slot = ToPrimitive<size_t>(JS_ARGV(cx, vp)[0]);
 	if (slot >= MAX_JS_TIMERS)
 		return JS_FALSE;
 
@@ -135,6 +135,8 @@
 	now.Subtract(js_timer_overhead);
 	BillingPolicy_Default()(&js_timer_clients[slot], js_start_times[slot], now);
 	js_start_times[slot].SetToZero();
+
+	JS_SET_RVAL(cx, vp, JSVAL_VOID);
 	return JS_TRUE;
 }
 
@@ -146,11 +148,13 @@
 // Immediately ends the current game (if any).
 // params:
 // returns:
-JSBool EndGame(JSContext* cx, JSObject*, uintN argc, jsval* argv, jsval* rval)
+JSBool EndGame(JSContext* cx, uintN argc, jsval* vp)
 {
 	JSU_REQUIRE_NO_PARAMS();
 
 	EndGame();
+
+	JS_SET_RVAL(cx, vp, JSVAL_VOID);
 	return JS_TRUE;
 }
 
@@ -164,13 +168,13 @@
 // notes:
 // - This value is recalculated once a frame. We take special care to
 //   filter it, so it is both accurate and free of jitter.
-JSBool GetFps( JSContext* cx, JSObject*, uintN argc, jsval* argv, jsval* rval )
+JSBool GetFps(JSContext* cx, uintN argc, jsval* vp)
 {
 	JSU_REQUIRE_NO_PARAMS();
 	int freq = 0;
 	if (g_frequencyFilter)
 		freq = g_frequencyFilter->StableFrequency();
-	*rval = INT_TO_JSVAL(freq);
+	JS_SET_RVAL(cx, vp, INT_TO_JSVAL(freq));
 	return JS_TRUE;
 }
 
@@ -181,28 +185,13 @@
 // notes:
 // - Exit happens after the current main loop iteration ends
 //   (since this only sets a flag telling it to end)
-JSBool ExitProgram( JSContext* cx, JSObject*, uintN argc, jsval* argv, jsval* rval )
+JSBool ExitProgram(JSContext* cx, uintN argc, jsval* vp)
 {
 	JSU_REQUIRE_NO_PARAMS();
 
 	kill_mainloop();
-	return JS_TRUE;
-}
 
-
-// Write an indication of total video RAM to console.
-// params:
-// returns:
-// notes:
-// - May not be supported on all platforms.
-// - Only a rough approximation; do not base low-level decisions
-//   ("should I allocate one more texture?") on this.
-JSBool WriteVideoMemToConsole( JSContext* cx, JSObject*, uintN argc, jsval* argv, jsval* rval )
-{
-	JSU_REQUIRE_NO_PARAMS();
-
-	const SDL_VideoInfo* videoInfo = SDL_GetVideoInfo();
-	g_Console->InsertMessage(L"VRAM: total %d", videoInfo->video_mem);
+	JS_SET_RVAL(cx, vp, JSVAL_VOID);
 	return JS_TRUE;
 }
 
@@ -212,38 +201,27 @@
 // returns:
 // notes:
 // - Cursors are stored in "art\textures\cursors"
-JSBool SetCursor( JSContext* cx, JSObject*, uintN argc, jsval* argv, jsval* rval )
+JSBool SetCursor(JSContext* cx, uintN argc, jsval* vp)
 {
 	JSU_REQUIRE_PARAMS(1);
-	g_CursorName = g_ScriptingHost.ValueToUCString(argv[0]);
+	g_CursorName = g_ScriptingHost.ValueToUCString(JS_ARGV(cx, vp)[0]);
+
+	JS_SET_RVAL(cx, vp, JSVAL_VOID);
 	return JS_TRUE;
 }
 
-// Change the LOD bias.
-// params: LOD bias [float]
-// returns:
-// notes:
-// - value is as required by GL_TEXTURE_LOD_BIAS.
-// - useful for adjusting image "sharpness" (since it affects which mipmap level is chosen)
-JSBool _LodBias( JSContext* cx, JSObject*, uintN argc, jsval* argv, jsval* rval )
+JSBool GetGUIObjectByName(JSContext* cx, uintN argc, jsval* vp)
 {
 	JSU_REQUIRE_PARAMS(1);
 
-	g_Renderer.SetOptionFloat(CRenderer::OPT_LODBIAS, ToPrimitive<float>(argv[0]));
-	return JS_TRUE;
-}
-
-
-JSBool GetGUIObjectByName(JSContext* cx, JSObject* UNUSED(obj), uintN UNUSED(argc), jsval* argv, jsval* rval)
-{
 	try
 	{
-		CStr name = ToPrimitive<CStr>(cx, argv[0]);
+		CStr name = ToPrimitive<CStr>(cx, JS_ARGV(cx, vp)[0]);
 		IGUIObject* guiObj = g_GUI->FindObjectByName(name);
 		if (guiObj)
-			*rval = OBJECT_TO_JSVAL(guiObj->GetJSObject());
+			JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(guiObj->GetJSObject()));
 		else
-			*rval = JSVAL_NULL;
+			JS_SET_RVAL(cx, vp, JSVAL_NULL);
 		return JS_TRUE;
 	}
 	catch (PSERROR_Scripting&)
@@ -270,14 +248,14 @@
 //   lib/svn_revision.cpp. it is useful to know when attempting to
 //   reproduce bugs (the main EXE and PDB should be temporarily reverted to
 //   that revision so that they match user-submitted crashdumps).
-JSBool GetBuildTimestamp( JSContext* cx, JSObject*, uintN argc, jsval* argv, jsval* rval )
+JSBool GetBuildTimestamp(JSContext* cx, uintN argc, jsval* vp)
 {
 	JSU_REQUIRE_MAX_PARAMS(1);
 
 	char buf[200];
 
 	// see function documentation
-	const int mode = argc? JSVAL_TO_INT(argv[0]) : -1;
+	const int mode = argc? JSVAL_TO_INT(JS_ARGV(cx, vp)[0]) : -1;
 	switch(mode)
 	{
 	case -1:
@@ -294,7 +272,7 @@
 		break;
 	}
 
-	*rval = STRING_TO_JSVAL(JS_NewStringCopyZ(cx, buf));
+	JS_SET_RVAL(cx, vp, STRING_TO_JSVAL(JS_NewStringCopyZ(cx, buf)));
 	return JS_TRUE;
 }
 
@@ -311,8 +289,11 @@
 }
 #endif
 
-JSBool DumpHeaps(JSContext* UNUSED(cx), JSObject* UNUSED(globalObject), uintN UNUSED(argc), jsval* UNUSED(argv), jsval* UNUSED(rval) )
+JSBool DumpHeaps(JSContext* cx, uintN argc, jsval* vp)
 {
+	UNUSED2(cx);
+	UNUSED2(argc);
+
 #ifdef DEBUG
 	static int i = 0;
 
@@ -325,47 +306,50 @@
 #else
 	debug_warn(L"DumpHeaps only available in DEBUG mode");
 #endif
+
+	JS_SET_RVAL(cx, vp, JSVAL_VOID);
 	return JS_TRUE;
 }
 
 //-----------------------------------------------------------------------------
 
 // Is the game paused?
-JSBool IsPaused( JSContext* cx, JSObject* UNUSED(globalObject), uintN argc, jsval* argv, jsval* rval )
+JSBool IsPaused(JSContext* cx, uintN argc, jsval* vp)
 {
 	JSU_REQUIRE_NO_PARAMS();
 
-	if( !g_Game )
+	if (!g_Game)
 	{
-		JS_ReportError( cx, "Game is not started" );
+		JS_ReportError(cx, "Game is not started");
 		return JS_FALSE;
 	}
 
-	*rval = g_Game->m_Paused ? JSVAL_TRUE : JSVAL_FALSE;
-	return JS_TRUE ;
+	JS_SET_RVAL(cx, vp, g_Game->m_Paused ? JSVAL_TRUE : JSVAL_FALSE);
+	return JS_TRUE;
 }
 
 // Pause/unpause the game
-JSBool SetPaused( JSContext* cx, JSObject* UNUSED(globalObject), uintN argc, jsval* argv, jsval* rval )
+JSBool SetPaused(JSContext* cx, uintN argc, jsval* vp)
 {
 	JSU_REQUIRE_PARAMS( 1 );
 
-	if( !g_Game )
+	if (!g_Game)
 	{
-		JS_ReportError( cx, "Game is not started" );
+		JS_ReportError(cx, "Game is not started");
 		return JS_FALSE;
 	}
 
 	try
 	{
-		g_Game->m_Paused = ToPrimitive<bool>( argv[0] );
+		g_Game->m_Paused = ToPrimitive<bool> (JS_ARGV(cx, vp)[0]);
 	}
-	catch( PSERROR_Scripting_ConversionFailed )
+	catch (PSERROR_Scripting_ConversionFailed)
 	{
-		JS_ReportError( cx, "Invalid parameter to SetPaused" );
+		JS_ReportError(cx, "Invalid parameter to SetPaused");
 	}
 
-	return  JS_TRUE;
+	JS_SET_RVAL(cx, vp, JSVAL_VOID);
+	return JS_TRUE;
 }
 
 
@@ -381,7 +365,7 @@
 // - Extra (reserved for future use, always zero)
 //
 // we simplify this a bit with a macro:
-#define JS_FUNC(script_name, cpp_function, min_params) { script_name, cpp_function, min_params, 0, 0 },
+#define JS_FUNC(script_name, cpp_function, min_params) { script_name, cpp_function, min_params, 0 },
 
 JSFunctionSpec ScriptFunctionTable[] =
 {
@@ -404,8 +388,6 @@
 	JS_FUNC("exit", ExitProgram, 0)
 	JS_FUNC("isPaused", IsPaused, 0)
 	JS_FUNC("setPaused", SetPaused, 1)
-	JS_FUNC("vmem", WriteVideoMemToConsole, 0)
-	JS_FUNC("_lodBias", _LodBias, 0)
 	JS_FUNC("setCursor", SetCursor, 1)
 	JS_FUNC("getFPS", GetFps, 0)
 	JS_FUNC("getGUIObjectByName", GetGUIObjectByName, 1)
@@ -415,7 +397,7 @@
 	JS_FUNC("dumpHeaps", DumpHeaps, 0)
 
 	// end of table marker
-	{0, 0, 0, 0, 0}
+	{0}
 };
 #undef JS_FUNC
 
@@ -424,23 +406,22 @@
 // property accessors
 //-----------------------------------------------------------------------------
 
-JSBool GetGameView( JSContext* UNUSED(cx), JSObject* UNUSED(obj), jsval UNUSED(id), jsval* vp )
+JSBool GetGameView(JSContext* UNUSED(cx), JSObject* UNUSED(obj), jsid UNUSED(id), jsval* vp)
 {
 	if (g_Game)
-		*vp = OBJECT_TO_JSVAL( g_Game->GetView()->GetScript() );
+		*vp = OBJECT_TO_JSVAL(g_Game->GetView()->GetScript());
 	else
 		*vp = JSVAL_NULL;
-	return( JS_TRUE );
+	return JS_TRUE;
 }
 
-
-JSBool GetRenderer( JSContext* UNUSED(cx), JSObject* UNUSED(obj), jsval UNUSED(id), jsval* vp )
+JSBool GetRenderer(JSContext* UNUSED(cx), JSObject* UNUSED(obj), jsid UNUSED(id), jsval* vp)
 {
 	if (CRenderer::IsInitialised())
-		*vp = OBJECT_TO_JSVAL( g_Renderer.GetScript() );
+		*vp = OBJECT_TO_JSVAL(g_Renderer.GetScript());
 	else
 		*vp = JSVAL_NULL;
-	return( JS_TRUE );
+	return JS_TRUE;
 }
 
 
@@ -455,9 +436,7 @@
 
 JSPropertySpec ScriptGlobalTable[] =
 {
-	{ "camera"     , GLOBAL_CAMERA,      JSPROP_PERMANENT, JSI_Camera::getCamera, JSI_Camera::setCamera },
 	{ "console"    , GLOBAL_CONSOLE,     JSPROP_PERMANENT|JSPROP_READONLY, JSI_Console::getConsole, 0 },
-	{ "lightenv"   , GLOBAL_LIGHTENV,    JSPROP_PERMANENT, JSI_LightEnv::getLightEnv, JSI_LightEnv::setLightEnv },
 	{ "gameView"   , 0,                  JSPROP_PERMANENT|JSPROP_READONLY, GetGameView, 0 },
 	{ "renderer"   , 0,                  JSPROP_PERMANENT|JSPROP_READONLY, GetRenderer, 0 },
 
diff -r 6b3ac7e864ba source/scripting/ScriptableObject.h
--- a/source/scripting/ScriptableObject.h	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/scripting/ScriptableObject.h	Thu Nov 04 14:52:01 2010 +0000
@@ -155,12 +155,12 @@
 	void Root()
 	{
 		if( JSVAL_IS_GCTHING( m_Data ) )
-			JS_AddNamedRoot( g_ScriptingHost.GetContext(), (void*)&m_Data, "ScriptableObjectProperty" );
+			JS_AddNamedValueRoot( g_ScriptingHost.GetContext(), &m_Data, "ScriptableObjectProperty" );
 	}
 	void Uproot()
 	{
 		if( JSVAL_IS_GCTHING( m_Data ))
-			JS_RemoveRoot( g_ScriptingHost.GetContext(), (void*)&m_Data );
+			JS_RemoveValueRoot( g_ScriptingHost.GetContext(), &m_Data );
 	}
 	jsval Get( JSContext* UNUSED(cx), IJSObject* UNUSED(object))
 	{
@@ -179,14 +179,14 @@
 template<typename T, bool ReadOnly, typename RType, RType (T::*NativeFunction)( JSContext* cx, uintN argc, jsval* argv )> class CNativeFunction
 {
 public:
-	static JSBool JSFunction( JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval )
+	static JSBool JSFunction( JSContext* cx, uintN argc, jsval* vp )
 	{
-		T* Native = ToNative<T>( cx, obj );
+		T* Native = ToNative<T>( cx, JS_THIS_OBJECT( cx, vp ) );
 		if( !Native )
-			return( JS_TRUE );
+			return( JS_FALSE );
 
-		*rval = ToJSVal<RType>( (Native->*NativeFunction)( cx, argc, argv ) );
-
+		jsval rval = ToJSVal<RType>( (Native->*NativeFunction)( cx, argc, JS_ARGV(cx, vp) ) );
+		JS_SET_RVAL( cx, vp, rval );
 		return( JS_TRUE );
 	}
 };
@@ -196,14 +196,15 @@
 class CNativeFunction<T, ReadOnly, void, NativeFunction>
 {
 public:
-	static JSBool JSFunction( JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* UNUSED(rval) )
+	static JSBool JSFunction( JSContext* cx, uintN argc, jsval* vp )
 	{
-		T* Native = ToNative<T>( cx, obj );
+		T* Native = ToNative<T>( cx, JS_THIS_OBJECT( cx, vp ) );
 		if( !Native )
-			return( JS_TRUE );
+			return( JS_FALSE );
 
-		(Native->*NativeFunction)( cx, argc, argv );
+		(Native->*NativeFunction)( cx, argc, JS_ARGV(cx, vp) );
 
+		JS_SET_RVAL( cx, vp, JSVAL_VOID );
 		return( JS_TRUE );
 	}
 };
@@ -328,7 +329,7 @@
 	template<typename ReturnType, ReturnType (T::*NativeFunction)( JSContext* cx, uintN argc, jsval* argv )> 
 		static void AddMethod( const char* Name, uintN MinArgs )
 	{
-		JSFunctionSpec FnInfo = { Name, CNativeFunction<T, ReadOnly, ReturnType, NativeFunction>::JSFunction, (uint8)MinArgs, 0, 0 };
+		JSFunctionSpec FnInfo = { Name, CNativeFunction<T, ReadOnly, ReturnType, NativeFunction>::JSFunction, (uint8)MinArgs, 0 };
 		m_Methods.push_back( FnInfo );
 	}
 	template<typename PropType> static void AddProperty( const CStrW& PropertyName, PropType T::*Native, bool PropReadOnly = ReadOnly )
@@ -373,7 +374,7 @@
 		{
 			m_JS = JS_NewObject( g_ScriptingHost.GetContext(), &JSI_class, NULL, NULL );
 			if( m_EngineOwned )
-				JS_AddNamedRoot( g_ScriptingHost.GetContext(), (void*)&m_JS, JSI_class.name );
+				JS_AddNamedObjectRoot( g_ScriptingHost.GetContext(), &m_JS, JSI_class.name );
 	
 			JS_SetPrivate( g_ScriptingHost.GetContext(), m_JS, (T*)this );
 		}
@@ -384,7 +385,7 @@
 		{
 			JS_SetPrivate( g_ScriptingHost.GetContext(), m_JS, NULL );
 			if( m_EngineOwned )
-				JS_RemoveRoot( g_ScriptingHost.GetContext(), &m_JS );
+				JS_RemoveObjectRoot( g_ScriptingHost.GetContext(), &m_JS );
 			m_JS = NULL;
 		}
 	}
@@ -393,26 +394,34 @@
 	// Functions and data that must be provided to JavaScript
 	// 
 private:
-	static JSBool JSGetProperty( JSContext* cx, JSObject* obj, jsval id, jsval* vp )
+	static JSBool JSGetProperty( JSContext* cx, JSObject* obj, jsid id, jsval* vp )
 	{
 		T* Instance = ToNative<T>( cx, obj );
 		if( !Instance )
 			return( JS_TRUE );
 
-		CStrW PropName = g_ScriptingHost.ValueToUCString( id );
+		jsval idval;
+		if( !JS_IdToValue( cx, id, &idval ) )
+			return( JS_FALSE );
+
+		CStrW PropName = g_ScriptingHost.ValueToUCString( idval );
 
 		if( !Instance->GetProperty( cx, PropName, vp ) )
 			return( JS_TRUE );
 		
 		return( JS_TRUE );
 	}
-	static JSBool JSSetProperty( JSContext* cx, JSObject* obj, jsval id, jsval* vp )
+	static JSBool JSSetProperty( JSContext* cx, JSObject* obj, jsid id, jsval* vp )
 	{
 		T* Instance = ToNative<T>( cx, obj );
 		if( !Instance )
 			return( JS_TRUE );
 
-		CStrW PropName = g_ScriptingHost.ValueToUCString( id );
+		jsval idval;
+		if( !JS_IdToValue( cx, id, &idval ) )
+			return( JS_FALSE );
+
+		CStrW PropName = g_ScriptingHost.ValueToUCString( idval );
 
 		Instance->SetProperty( cx, PropName, vp );
 
diff -r 6b3ac7e864ba source/scripting/ScriptingHost.cpp
--- a/source/scripting/ScriptingHost.cpp	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/scripting/ScriptingHost.cpp	Thu Nov 04 14:52:01 2010 +0000
@@ -168,12 +168,10 @@
 
 void ScriptingHost::SetObjectProperty_Double(JSObject* object, const char* propertyName, double value)
 {
-	jsdouble* d = JS_NewDouble(m_Context, value);
-	if (! d)
+	jsval v;
+	if (! JS_NewNumberValue(m_Context, value, &v))
 		throw PSERROR_Scripting_ConversionFailed();
 
-	jsval v = DOUBLE_TO_JSVAL(d);
-
 	if (! JS_SetProperty(m_Context, object, propertyName, &v))
 		throw PSERROR_Scripting_ConversionFailed();
 }
diff -r 6b3ac7e864ba source/scripting/SpiderMonkey.h
--- a/source/scripting/SpiderMonkey.h	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/scripting/SpiderMonkey.h	Thu Nov 04 14:52:01 2010 +0000
@@ -45,11 +45,6 @@
 
 #include <js/jsapi.h>
 
-#ifndef NDEBUG
-// Used by ScriptingHost::jshook_{script,function}
-# include <js/jsdbgapi.h>
-#endif
-
 // include any further required headers here
 
 #include "JSUtil.h"
diff -r 6b3ac7e864ba source/scriptinterface/AutoRooters.cpp
--- a/source/scriptinterface/AutoRooters.cpp	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/scriptinterface/AutoRooters.cpp	Thu Nov 04 14:52:01 2010 +0000
@@ -47,4 +47,15 @@
 	{
 		JS_CALL_VALUE_TRACER(trc, m_Vals[i], "AutoGCRooter val");
 	}
+
+	for (size_t i = 0; i < m_IdArrays.size(); ++i)
+	{
+		for (jsint j = 0; j < m_IdArrays[i]->length; ++j)
+		{
+			jsval val = JSVAL_VOID;
+			JS_IdToValue(m_ScriptInterface.GetContext(), m_IdArrays[i]->vector[j], &val);
+			JS_CALL_VALUE_TRACER(trc, val, "AutoGCRooter id array");
+		}
+	}
+
 }
diff -r 6b3ac7e864ba source/scriptinterface/AutoRooters.h
--- a/source/scriptinterface/AutoRooters.h	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/scriptinterface/AutoRooters.h	Thu Nov 04 14:52:01 2010 +0000
@@ -22,30 +22,6 @@
 
 #include "js/jsapi.h"
 
-// Exception-safety and GC-safety wrapper for JSIdArray
-// (TODO: it'd be nicer to use the existing js::AutoIdArray but currently that
-// requires a load of semi-private SpiderMonkey headers that cause a load of compile warnings)
-class IdArrayWrapper
-{
-	JSContext* m_cx;
-	JSIdArray* m_ida;
-public:
-	IdArrayWrapper(JSContext* cx, JSIdArray* ida) :
-		m_cx(cx), m_ida(ida)
-	{
-		for (jsint i = 0; i < m_ida->length; ++i)
-			if (!JS_AddRoot(m_cx, &m_ida->vector[i]))
-				debug_warn(L"JS_AddRoot failed");
-	}
-	~IdArrayWrapper()
-	{
-		for (jsint i = 0; i < m_ida->length; ++i)
-			if (!JS_RemoveRoot(m_cx, &m_ida->vector[i]))
-				debug_warn(L"JS_RemoveRoot failed");
-		JS_DestroyIdArray(m_cx, m_ida);
-	}
-};
-
 /**
  * Helper for rooting large groups of script values.
  * Construct this object, push values into it, and they will all be rooted until this
@@ -61,6 +37,7 @@
 
 	void Push(JSObject* obj) { m_Objects.push_back(obj); }
 	void Push(jsval val) { m_Vals.push_back(val); }
+	void Push(JSIdArray* ida) { m_IdArrays.push_back(ida); }
 
 	void Trace(JSTracer* trc);
 private:
@@ -69,6 +46,7 @@
 
 	std::vector<JSObject*> m_Objects;
 	std::vector<jsval> m_Vals;
+	std::vector<JSIdArray*> m_IdArrays;
 	// TODO: add vectors of other value types
 };
 
